> ## Documentation Index
> Fetch the complete documentation index at: https://docs.domino.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Recreates a previously-run workflow execution that will only start executing from the last known

> Recreates a previously-run workflow execution that will only start executing from the last known failure point. In Recover mode, users cannot change any input parameters or update the version of the execution. This is extremely useful to recover from system errors and byzantine faults like - Loss of K8s cluster, bugs in platform or instability, machine failures, downstream system failures (downstream services), or simply to recover executions that failed because of retry exhaustion and should complete if tried again.



## OpenAPI

````yaml /api-specs/cloud/flyte-native-api.json post /api/v1/executions/recover
openapi: 3.0.3
info:
  description: >-
    Reference for the upstream Flyte control plane API, which backs Domino
    Flows.
  title: Flyte native API
  version: version not set
servers:
  - description: >-
      Replace 'mycluster.domino.tech' with your Domino cluster hostname. For
      Domino Cloud customers, that is `your-subdomain`.domino.tech (e.g.,
      acme.domino.tech). For self-hosted deployments, it is the hostname you
      reach the Domino UI at.
    url: https://mycluster.domino.tech/flows
security: []
tags:
  - name: Children
  - name: Data
  - name: Description entities
  - name: Domains
  - name: Events
  - name: Executions
  - name: Launch plans
  - name: Matchable attributes
  - name: Metrics
  - name: Named entities
  - name: Node executions
  - name: Project attributes
  - name: Project domain attributes
  - name: Projects
  - name: Task executions
  - name: Tasks
  - name: Version
  - name: Workflow attributes
  - name: Workflows
paths:
  /api/v1/executions/recover:
    post:
      tags:
        - Executions
      summary: >-
        Recreates a previously-run workflow execution that will only start
        executing from the last known
      description: >-
        Recreates a previously-run workflow execution that will only start
        executing from the last known failure point. In Recover mode, users
        cannot change any input parameters or update the version of the
        execution. This is extremely useful to recover from system errors and
        byzantine faults like - Loss of K8s cluster, bugs in platform or
        instability, machine failures, downstream system failures (downstream
        services), or simply to recover executions that failed because of retry
        exhaustion and should complete if tried again.
      operationId: AdminService_RecoverExecution
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/adminExecutionRecoverRequest'
        description: Request to recover the referenced execution.
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/adminExecutionCreateResponse'
          description: A successful response.
        default:
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/googlerpcStatus'
          description: An unexpected error response.
components:
  schemas:
    adminExecutionRecoverRequest:
      description: Request to recover the referenced execution.
      properties:
        id:
          $ref: '#/components/schemas/coreWorkflowExecutionIdentifier'
        metadata:
          $ref: '#/components/schemas/adminExecutionMetadata'
        name:
          title: |-
            User provided value for the recovered execution.
            If none is provided the system will generate a unique string.
            +optional
          type: string
      type: object
    adminExecutionCreateResponse:
      description: >-
        The unique identifier for a successfully created execution.

        If the name was *not* specified in the create request, this identifier
        will include a generated name.
      properties:
        id:
          $ref: '#/components/schemas/coreWorkflowExecutionIdentifier'
      type: object
    googlerpcStatus:
      properties:
        code:
          format: int32
          type: integer
        details:
          items:
            $ref: '#/components/schemas/protobufAny'
          type: array
        message:
          type: string
      type: object
    coreWorkflowExecutionIdentifier:
      properties:
        domain:
          description: |-
            Name of the domain the resource belongs to.
            A domain can be considered as a subset within a specific project.
          type: string
        name:
          description: User or system provided value for the resource.
          type: string
        org:
          description: Optional, org key applied to the resource.
          type: string
        project:
          description: Name of the project the resource belongs to.
          type: string
      title: >-
        Encapsulation of fields that uniquely identifies a Flyte workflow
        execution
      type: object
    adminExecutionMetadata:
      description: >-
        Represents attributes about an execution which are not required to
        launch the execution but are useful to record.

        These attributes are assigned at launch time and do not change.
      properties:
        artifact_ids:
          description: >-
            Save a list of the artifacts used in this execution for now. This is
            a list only rather than a mapping

            since we don't have a structure to handle nested ones anyways.
          items:
            $ref: '#/components/schemas/coreArtifactID'
          type: array
        mode:
          $ref: '#/components/schemas/adminExecutionMetadataExecutionMode'
        nesting:
          description: >-
            Indicates the nestedness of this execution.

            If a user launches a workflow execution, the default nesting is 0.

            If this execution further launches a workflow (child workflow), the
            nesting level is incremented by 0 => 1

            Generally, if workflow at nesting level k launches a workflow then
            the child workflow will have

            nesting = k + 1.
          format: int64
          type: integer
        parent_node_execution:
          $ref: '#/components/schemas/coreNodeExecutionIdentifier'
        principal:
          description: >-
            Identifier of the entity that triggered this execution.

            For systems using back-end authentication any value set here will be
            discarded in favor of the

            authenticated user context.
          type: string
        reference_execution:
          $ref: '#/components/schemas/coreWorkflowExecutionIdentifier'
        scheduled_at:
          description: >-
            For scheduled executions, the requested time for execution for this
            specific schedule invocation.
          format: date-time
          type: string
        system_metadata:
          $ref: '#/components/schemas/adminSystemMetadata'
      type: object
    protobufAny:
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
      properties:
        '@type':
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
          type: string
      type: object
    coreArtifactID:
      properties:
        artifact_key:
          $ref: '#/components/schemas/coreArtifactKey'
        partitions:
          $ref: '#/components/schemas/corePartitions'
        time_partition:
          $ref: '#/components/schemas/coreTimePartition'
        version:
          type: string
      type: object
    adminExecutionMetadataExecutionMode:
      default: MANUAL
      description: |-
        The method by which this execution was launched.

         - MANUAL: The default execution mode, MANUAL implies that an execution was launched by an individual.
         - SCHEDULED: A schedule triggered this execution launch.
         - SYSTEM: A system process was responsible for launching this execution rather an individual.
         - RELAUNCH: This execution was launched with identical inputs as a previous execution.
         - CHILD_WORKFLOW: This execution was triggered by another execution.
         - RECOVERED: This execution was recovered from another execution.
         - TRIGGER: Execution was kicked off by the artifact trigger system
      enum:
        - MANUAL
        - SCHEDULED
        - SYSTEM
        - RELAUNCH
        - CHILD_WORKFLOW
        - RECOVERED
        - TRIGGER
      type: string
    coreNodeExecutionIdentifier:
      description: Encapsulation of fields that identify a Flyte node execution entity.
      properties:
        execution_id:
          $ref: '#/components/schemas/coreWorkflowExecutionIdentifier'
        node_id:
          type: string
      type: object
    adminSystemMetadata:
      description: Represents system, rather than user-facing, metadata about an execution.
      properties:
        execution_cluster:
          description: Which execution cluster this execution ran on.
          type: string
        namespace:
          description: Which kubernetes namespace the execution ran under.
          type: string
      type: object
    coreArtifactKey:
      properties:
        domain:
          type: string
        name:
          type: string
        org:
          type: string
        project:
          description: >-
            Project and domain and suffix needs to be unique across a given
            artifact store.
          type: string
      type: object
    corePartitions:
      properties:
        value:
          additionalProperties:
            $ref: '#/components/schemas/coreLabelValue'
          type: object
      type: object
    coreTimePartition:
      properties:
        granularity:
          $ref: '#/components/schemas/coreGranularity'
        value:
          $ref: '#/components/schemas/coreLabelValue'
      type: object
    coreLabelValue:
      properties:
        input_binding:
          $ref: '#/components/schemas/coreInputBindingData'
        runtime_binding:
          $ref: '#/components/schemas/coreRuntimeBinding'
        static_value:
          title: The string static value is for use in the Partitions object
          type: string
        time_value:
          format: date-time
          title: The time value is for use in the TimePartition case
          type: string
        triggered_binding:
          $ref: '#/components/schemas/coreArtifactBindingData'
      type: object
    coreGranularity:
      default: UNSET
      enum:
        - UNSET
        - MINUTE
        - HOUR
        - DAY
        - MONTH
      title: '- DAY: default'
      type: string
    coreInputBindingData:
      properties:
        var:
          type: string
      type: object
    coreRuntimeBinding:
      type: object
    coreArtifactBindingData:
      properties:
        bind_to_time_partition:
          type: boolean
        partition_key:
          type: string
        time_transform:
          $ref: '#/components/schemas/coreTimeTransform'
      title: Only valid for triggers
      type: object
    coreTimeTransform:
      properties:
        op:
          $ref: '#/components/schemas/flyteidlcoreOperator'
        transform:
          type: string
      type: object
    flyteidlcoreOperator:
      default: MINUS
      enum:
        - MINUS
        - PLUS
      type: string

````

## Related topics

- [Creates or updates custom MatchableAttributesConfiguration for a project, domain and workflow.](/api-reference/workflow-attributes/creates-or-updates-custom-matchableattributesconfiguration-for-a-project-domain-and-workflow.md)
- [Fetches custom MatchableAttributesConfiguration for a project, domain and workflow.](/api-reference/workflow-attributes/fetches-custom-matchableattributesconfiguration-for-a-project-domain-and-workflow.md)
- [Fetches runtime metrics for a Execution.](/api-reference/metrics/fetches-runtime-metrics-for-a-execution.md)
- [Deletes custom MatchableAttributesConfiguration for a project, domain and workflow.](/api-reference/workflow-attributes/deletes-custom-matchableattributesconfiguration-for-a-project-domain-and-workflow.md)
